package com.liaobo.im.adapter;

import android.content.Context;
import android.support.annotation.NonNull;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.bean.SignInStatus;
import com.liaobo.im.util.TimeUtils;

import java.util.List;

public class SignInAdapter extends RecyclerView.Adapter<SignInAdapter.ViewHolder> {

    private Context context;
    private List<SignInStatus.RecordsBean> data;

    public SignInAdapter(Context context, List<SignInStatus.RecordsBean> data){
        this.context = context;
        this.data = data;
    }

    public void setNewData(List<SignInStatus.RecordsBean> data){
        this.data = data;
        notifyDataSetChanged();
    }

    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.item_sign_in,parent,false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, final int position) {
        holder.name.setText("领取"+data.get(position).getMoney()+"红包");
        holder.time.setText(TimeUtils.f_long_2_str(data.get(position).getGmtCreate()));

//        holder.itemView.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
////                Log.e("这里是点击每一行item的响应事件",""+position+item);
//            }
//        });

    }

    @Override
    public int getItemCount() {
        return data==null? 0:data.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder{

        private TextView name;
        private TextView time;

        public ViewHolder(View itemView) {
            super(itemView);
            name = itemView.findViewById(R.id.tv_name);
            time = itemView.findViewById(R.id.tv_times);

        }
    }
}