package com.liaobo.im.fragment;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.ui.MainActivity;
import com.liaobo.im.ui.base.EasyFragment;
import com.liaobo.im.ui.company.ManagerCompany;
import com.liaobo.im.ui.contacts.PublishNumberActivity;
import com.liaobo.im.ui.contacts.label.LabelActivity;
import com.liaobo.im.ui.me.FriendsCircleFragmentActivity;
import com.liaobo.im.ui.me.LifeCircleActivity;
import com.liaobo.im.ui.me.NearPersonActivity;
import com.liaobo.im.util.Constants;
import com.liaobo.im.util.UiUtils;
import com.liaobo.im.util.Util;
import com.tencent.mm.opensdk.modelmsg.SendMessageToWX;
import com.tencent.mm.opensdk.modelmsg.WXMediaMessage;
import com.tencent.mm.opensdk.modelmsg.WXWebpageObject;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;

public class FindFragment extends EasyFragment implements View.OnClickListener {

    private TextView mTvTitle;

    private IWXAPI api;
    private static final int THUMB_SIZE = 150;

    public FindFragment() {
    }

    @Override
    protected int inflateLayoutId() {
        return R.layout.fragment_find;
    }

    @Override
    protected void onActivityCreated(Bundle savedInstanceState, boolean createView) {
        if (createView) {
            initView();
        }
    }

    private void initView() {
        api = WXAPIFactory.createWXAPI(getActivity(), Constants.VX_APP_ID, false);
        findViewById(R.id.iv_title_left).setVisibility(View.GONE);
        mTvTitle = (TextView) findViewById(R.id.tv_title_center);
        mTvTitle.setText(R.string.find);

        findViewById(R.id.ll_my_monry).setOnClickListener(this);
        findViewById(R.id.ll_my_space).setOnClickListener(this);
        findViewById(R.id.ll_my_collection).setOnClickListener(this);
        findViewById(R.id.my_sign_rl).setOnClickListener(this);
        findViewById(R.id.ll_scanning).setOnClickListener(this);
        findViewById(R.id.colleague_rl).setOnClickListener(this);
        findViewById(R.id.notice_rl).setOnClickListener(this);
        findViewById(R.id.label_rl).setOnClickListener(this);

    }

    @Override
    public void onClick(View v) {
        if (!UiUtils.isNormalClick(v)) {
            return;
        }
        int id = v.getId();
        switch (id) {
            case R.id.ll_my_monry:
                // 朋友圈
                startActivity(new Intent(getActivity(), FriendsCircleFragmentActivity.class));
                break;
            case R.id.ll_my_space:
                // 动态广场
                startActivity(new Intent(getActivity(), LifeCircleActivity.class));
                break;
            case R.id.ll_my_collection:
                // 邀请微信好友
                inviteFriends();
                break;
            case R.id.my_sign_rl:
                //附近人
                startActivity(new Intent(getActivity(), NearPersonActivity.class));
                break;
            case R.id.ll_scanning:
                // 扫一扫
                MainActivity.requestQrCodeScan(getActivity());
                break;
            case R.id.colleague_rl:
                ManagerCompany.start(requireContext());
                break;
            case R.id.notice_rl:
                Intent intentNotice = new Intent(getActivity(), PublishNumberActivity.class);
                getActivity().startActivity(intentNotice);
                break;
            case R.id.label_rl:
                LabelActivity.start(requireContext());
                break;
        }
    }

    private void inviteFriends(){
        WXWebpageObject webpage = new WXWebpageObject();
        webpage.webpageUrl = "https://dibaqu.com/ZFZN";
        WXMediaMessage msg = new WXMediaMessage(webpage);
        msg.title = "加入聊啵，领取签到红包，有机会领取888现金红包";
        if (!TextUtils.isEmpty(coreManager.getSelf().getMyInviteCode())){
            msg.description = "加入聊啵，领取签到红包，填写邀请码："+coreManager.getSelf().getMyInviteCode()+",你我都获利";
        }
        Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.mipmap.icon);
        Bitmap thumbBmp = Bitmap.createScaledBitmap(bmp, THUMB_SIZE, THUMB_SIZE, true);
        bmp.recycle();
        msg.thumbData = Util.bmpToByteArray(thumbBmp, true);

        SendMessageToWX.Req req = new SendMessageToWX.Req();
        req.transaction = buildTransaction("webpage");
        req.message = msg;
        req.scene = SendMessageToWX.Req.WXSceneSession;
        api.sendReq(req);

    }

    private String buildTransaction(final String type) {
        return (type == null) ? String.valueOf(System.currentTimeMillis()) : type + System.currentTimeMillis();
    }
}
