package com.liaobo.im.ui.account;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.TextUtils;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.airbnb.lottie.LottieAnimationView;
import com.liaobo.im.R;
import com.liaobo.im.adapter.SignInAdapter;
import com.liaobo.im.bean.SignInStatus;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.util.Constants;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.util.Util;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.BaseCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ObjectResult;
import com.tencent.mm.opensdk.modelmsg.SendMessageToWX;
import com.tencent.mm.opensdk.modelmsg.WXMediaMessage;
import com.tencent.mm.opensdk.modelmsg.WXWebpageObject;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import okhttp3.Call;

public class SignInActivity extends BaseActivity {

    private ImageView mIvSignInBtn;
    private TextView mTvSign, mTvSignLastNum, mTvSignNum, mTvSignInvite;
    private RecyclerView mRvSignList;

    private LinearLayout mLlAcceptRed;
    private LottieAnimationView mAnimationViewRed;
    private TextView mTvGetMoney, mTvAcceptRed;

    private SignInStatus signInStatus;
    private SignInAdapter adapter;
    private List<SignInStatus.RecordsBean> mRecordBean = new ArrayList<>();

    private LottieAnimationView animationView;

    private IWXAPI api;
    private static final int THUMB_SIZE = 150;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sign_in);
        api = WXAPIFactory.createWXAPI(this, Constants.VX_APP_ID, false);

        initActionBar();
        initView();
        initData();
    }

    private void initActionBar() {
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        TextView mTvTitle = (TextView) findViewById(R.id.tv_title_center);
        mTvTitle.setText(getString(R.string.my_sign_in));
    }

    private void initView() {
        mTvSign = (TextView) findViewById(R.id.tv_sign);
        mIvSignInBtn = (ImageView) findViewById(R.id.iv_sign_in_btn);
        mTvSignLastNum = (TextView) findViewById(R.id.tv_sign_last_num);
        mTvSignNum = (TextView) findViewById(R.id.tv_sign_num);
        mTvSignInvite = (TextView) findViewById(R.id.tv_sign_invite);

        mRvSignList = (RecyclerView) findViewById(R.id.rv_sign_list);

        adapter = new SignInAdapter(this, mRecordBean);
        mRvSignList.setLayoutManager(new LinearLayoutManager(this));
        mRvSignList.setAdapter(adapter);

        mLlAcceptRed = (LinearLayout) findViewById(R.id.ll_accept_red);
        mTvGetMoney = (TextView) findViewById(R.id.tv_get_money);
        mTvAcceptRed = (TextView) findViewById(R.id.tv_accept_red);
        animationView = (LottieAnimationView) findViewById(R.id.animation_view);
//        animationView.setAnimation("lottie_left.json");
        animationView.loop(true);
        animationView.playAnimation();

        mAnimationViewRed = (LottieAnimationView) findViewById(R.id.animation_view_red);
        mAnimationViewRed.loop(true);
        mAnimationViewRed.playAnimation();

        mIvSignInBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (signInStatus.getSurplusCount()>0) {
                    signIn();
                }
            }
        });
        mTvSignInvite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WXWebpageObject webpage = new WXWebpageObject();
                webpage.webpageUrl = "https://dibaqu.com/ZFZN";
                WXMediaMessage msg = new WXMediaMessage(webpage);
                msg.title = "加入聊啵，领取签到红包，有机会领取888现金红包";
                if (!TextUtils.isEmpty(coreManager.getSelf().getMyInviteCode())){
                    msg.description = "加入聊啵，领取签到红包，填写邀请码："+coreManager.getSelf().getMyInviteCode()+",你我都获利";
                }
                Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.mipmap.icon);
                Bitmap thumbBmp = Bitmap.createScaledBitmap(bmp, THUMB_SIZE, THUMB_SIZE, true);
                bmp.recycle();
                msg.thumbData = Util.bmpToByteArray(thumbBmp, true);

                SendMessageToWX.Req req = new SendMessageToWX.Req();
                req.transaction = buildTransaction("webpage");
                req.message = msg;
                req.scene = SendMessageToWX.Req.WXSceneSession;
                api.sendReq(req);

            }
        });
        mTvAcceptRed.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                mLlAcceptRed.setVisibility(View.GONE);
            }
        });

    }

    private void initData() {
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);

        HttpUtils.get().url(coreManager.getConfig().SIGN_IN_STATIUS)
//        HttpUtils.get().url("http://eolinker.autu.live/server/index.php?g=Web&c=Mock&o=simple&projectID=3&uri=/user/signin/pack/info&time=1576392852&secret=44daefaa0c6c7b6f59976798f5996e7e&access_token=caaed74185504f6b835b7d90573c2aef")
                .params(params)
                .build()
                .execute(new BaseCallback<SignInStatus>(SignInStatus.class) {

                    @Override
                    public void onResponse(ObjectResult<SignInStatus> result) {
                        if (result.getResultCode() == 1 && result.getData() != null) {
                            DecimalFormat decimalFormat = new DecimalFormat("0.00");
                            signInStatus = result.getData();
                            if (!signInStatus.isDone()) {
                                mTvSign.setText("签");
                            } else {
                                mTvSign.setText("已签到");
                                mTvSignInvite.setVisibility(View.VISIBLE);
                            }
                            mTvSignLastNum.setText("剩余签到次数：" + signInStatus.getSurplusCount() + "次");
                            mTvSignNum.setText("已累计签到" + (signInStatus.getTotalCount() - signInStatus.getSurplusCount()) + "次，加油，快赢得红包了");
//                            coreManager.getSelf().setBalance(Double.parseDouble(decimalFormat.format(balance.getBalance())));
//                            mBalanceTv.setText("￥" + decimalFormat.format(Double.parseDouble(decimalFormat.format(balance.getBalance()))));
                            adapter.setNewData(signInStatus.getRecords());

                        } else {
                            ToastUtil.showErrorData(SignInActivity.this);
                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        ToastUtil.showNetError(SignInActivity.this);
                    }
                });
    }

    private void signIn() {
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);

        HttpUtils.get().url(coreManager.getConfig().SIGN_IN)
//        HttpUtils.get().url("http://eolinker.autu.live/server/index.php?g=Web&c=Mock&o=simple&projectID=3&uri=/user/signin/pack/open&time=1576392852&secret=44daefaa0c6c7b6f59976798f5996e7e&access_token=caaed74185504f6b835b7d90573c2aef")
                .params(params)
                .build()
                .execute(new BaseCallback<SignInStatus>(SignInStatus.class) {

                    @Override
                    public void onResponse(ObjectResult<SignInStatus> result) {
                        if (result.getResultCode() == 1 && result.getData() != null) {
//                            DecimalFormat decimalFormat = new DecimalFormat("0.00");
                            SignInStatus balance = result.getData();
//                            mTvSignLastNum.setText("剩余签到次数：" + balance.getSurplusCount() + "次");
//                            mTvSignNum.setText("已累计签到" + (balance.getTotalCount() - balance.getSurplusCount()) + "次，加油，快赢得红包了");
//                            coreManager.getSelf().setBalance(Double.parseDouble(decimalFormat.format(balance.getBalance())));
//                            mBalanceTv.setText("￥" + decimalFormat.format(Double.parseDouble(decimalFormat.format(balance.getBalance()))));

//                            adapter.setNewData(balance.getRecords());
//                            ToastUtil.showToast(SignInActivity.this, "签到成功");
                            if (balance!=null) {
                                mTvGetMoney.setText("恭喜您，获得" + balance.getMoney() + "元现金红包");
                                mLlAcceptRed.setVisibility(View.VISIBLE);
                                initData();
                            }
                        } else {
                            ToastUtil.showToast(SignInActivity.this, result.getResultMsg());
//                            ToastUtil.showErrorData(SignInActivity.this);
                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        ToastUtil.showNetError(SignInActivity.this);
                    }
                });
    }

    private String buildTransaction(final String type) {
        return (type == null) ? String.valueOf(System.currentTimeMillis()) : type + System.currentTimeMillis();
    }
}
