package com.liaobo.im.ui.base;

import android.text.TextUtils;

import com.liaobo.im.R;
import com.liaobo.im.bean.CertificationBean;
import com.liaobo.im.ui.dialog.VerifiedDialogView;
import com.liaobo.im.util.PreferenceUtils;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.view.ChatBottomView;
import com.liaobo.im.view.ChatContentView;
import com.liaobo.im.view.SelectCardPopupWindow;
import com.liaobo.im.xmpp.listener.ChatMessageListener;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.BaseCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ObjectResult;

import java.util.HashMap;

import okhttp3.Call;

public abstract class BaseChatActivity extends BaseActivity implements
        ChatContentView.MessageEventListener, ChatBottomView.ChatBottomListener, ChatMessageListener, SelectCardPopupWindow.SendCardS {




    protected void checkVerified(){
        new VerifiedDialogView(this, ((name, id) -> {
            makeVerified(name,id);
        })).show();
    }


    private void makeVerified(String name, String id) {
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        params.put("realName", name);
        params.put("idcard", id);

        HttpUtils.get().url(coreManager.getConfig().MAKE_VERIFIED)
                .params(params)
                .build()
                .execute(new BaseCallback<CertificationBean>(CertificationBean.class) {

                    @Override
                    public void onResponse(ObjectResult<CertificationBean> result) {
                        CertificationBean certificationBean = result.getData();
                        if (result.getResultCode() == 1 && certificationBean!=null) {
                            if (result.getResultCode() == 1 && result.getData()!=null) {
                                CertificationBean bean = result.getData();
                                if (bean.isCertification()){
                                    ToastUtil.showToast(getApplicationContext() ,"实名认证已通过");
                                    PreferenceUtils.putString(getApplicationContext(), "isVerified", "true");
                                }else {
                                    if (  TextUtils.isEmpty(result.getResultMsg())){
                                        ToastUtil.showToast(getApplicationContext(),"实名认证失败" );
                                    }else {
                                        ToastUtil.showToast(getApplicationContext(),result.getResultMsg() );
                                    }
                                }
                            }

                        }else {

                            ToastUtil.showToast(BaseChatActivity.this, result.getResultMsg());
                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {

                        ToastUtil.showNetError(BaseChatActivity.this);
                    }
                });
    }

    protected boolean isVerified(){
        String isVerified = PreferenceUtils.getString(this, "isVerified");
        return "true".equals(isVerified);

    }
}
