package com.liaobo.im.ui.dialog;

import android.app.Activity;
import android.view.View;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.ui.dialog.base.BaseDialog;
import com.liaobo.im.util.SkinUtils;

/**
 * Created by Administrator on 2016/4/21.
 */
public class VerifiedDialogView extends BaseDialog {

    private TextView mTitleTv;
    private AutoCompleteTextView mContentET, mTvCardid;
    private Button mCommitBtn;
    private OnVerifiedListener mOnClickListener;

    {
        RID = R.layout.dialog_verified;
    }

    public VerifiedDialogView(Activity activity) {
        mActivity = activity;
        initView();
    }

    public VerifiedDialogView(Activity activity, OnVerifiedListener onClickListener) {
        mActivity = activity;
        initView();
        mOnClickListener = onClickListener;
    }

    protected void initView() {
        super.initView();
        mTitleTv = (TextView) mView.findViewById(R.id.title);
//        mTitleTv.setText(InternationalizationHelper.getString("JXNewRoomVC_CreatRoom"));

        mContentET = (AutoCompleteTextView) mView.findViewById(R.id.content);
        mTvCardid = (AutoCompleteTextView) mView.findViewById(R.id.tv_cardid);

        mCommitBtn = (Button) mView.findViewById(R.id.sure_btn);
        mCommitBtn.setBackgroundColor(SkinUtils.getSkin(mActivity).getAccentColor());
        mCommitBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                mOnClickListener.click(mContentET.getText().toString(), mTvCardid.getText().toString());
                mDialog.dismiss();
            }
        });
    }

    public void setSureClick(OnVerifiedListener onClickListener) {
        mOnClickListener = onClickListener;
    }

    public interface OnVerifiedListener{
        void click(String name, String id);
    }

}
