package com.liaobo.im.ui.me;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.widget.SwitchCompat;
import android.widget.TextView;
import android.widget.Toast;

import com.liaobo.im.R;
import com.liaobo.im.bean.PrivacySetting;
import com.liaobo.im.bean.redpacket.RedSendRedItemEntry;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.helper.PrivacySettingHelper;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.ui.me.redpacket.MyRedPacketActivity;
import com.liaobo.im.ui.me.redpacket.RedListActivity;
import com.liaobo.im.util.PreferenceUtils;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.BaseCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ObjectResult;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.Result;

import java.util.HashMap;
import java.util.Map;

import okhttp3.Call;

/**
 * 辅助功能
 */
public class AccessibilityActivity extends BaseActivity  {
    private SwitchCompat mSwitchCompat;
    private boolean isAutoGetAssign;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_accessibility);
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(view -> finish());
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
        tvTitle.setText(R.string.accessibility);
        mSwitchCompat = findViewById(R.id.switch_auto);
        mSwitchCompat.setOnCheckedChangeListener( (compoundButton, bool) -> {
            int type = 0;
            if (bool){
                type = 1;
            }
            if (bool!= isAutoGetAssign){
                updateAutoGetAssign(type);

            }

        });
        findViewById(R.id.flt_packet_record).setOnClickListener(view -> {
            Intent intent = new Intent(this,RedListActivity.class);
            intent.putExtra(RedListActivity.ADAPTER_TYPE,2);
            startActivity(intent);
        });
        getPrivacySetting();



    }


    private void updateAutoGetAssign(int autoType){
        DialogHelper.showMessageProgressDialog(this,"请稍等...");
        Map<String, String> params = new HashMap<>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        params.put("userId", coreManager.getSelf().getUserId());
        params.put("isAutoGetAssign", String.valueOf(autoType));

        HttpUtils.get().url(coreManager.getConfig().USER_SET_PRIVACY_SETTING)
                .params(params)
                .build()
                .execute(new BaseCallback<Void>(Void.class) {

                    @Override
                    public void onResponse(ObjectResult<Void> result) {
                        DialogHelper.dismissProgressDialog();
                        if (Result.checkSuccess(AccessibilityActivity.this, result)) {
                            Toast.makeText(AccessibilityActivity.this, getString(R.string.update_success), Toast.LENGTH_SHORT).show();
                            setAutoGetAssignStatus(!isAutoGetAssign);


                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showErrorNet(mContext);
                        setAutoGetAssignStatus(isAutoGetAssign);
                    }
                });
    }


    // 获取用户的设置状态
    private void getPrivacySetting() {
        Map<String, String> params = new HashMap<>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        params.put("userId", coreManager.getSelf().getUserId());
        DialogHelper.showDefaulteMessageProgressDialog(this);

        HttpUtils.get().url(coreManager.getConfig().USER_GET_PRIVACY_SETTING)
                .params(params)
                .build()
                .execute(new BaseCallback<PrivacySetting>(PrivacySetting.class) {

                    @Override
                    public void onResponse(ObjectResult<PrivacySetting> result) {
                        DialogHelper.dismissProgressDialog();
                        if (Result.checkSuccess(AccessibilityActivity.this, result)) {
                            setAutoGetAssignStatus(result.getData().isAutoGetAssign());
                        }

                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showNetError(AccessibilityActivity.this);

                    }
                });
    }

    private void setAutoGetAssignStatus(boolean autoType){
        isAutoGetAssign = autoType;
        mSwitchCompat.setChecked(isAutoGetAssign);

    }
}
