package com.liaobo.im.ui.me;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.bean.InputCard;
import com.liaobo.im.bean.Prefix;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.util.EventBusHelper;
import com.liaobo.im.util.RegexUtils;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.JsonCallback;

import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.ListIterator;

import de.greenrobot.event.Subscribe;
import de.greenrobot.event.ThreadMode;
import okhttp3.Call;

/**
 * 绑定账号
 */
public class AddBankCardActivity extends BaseActivity implements View.OnClickListener, AdapterView.OnItemClickListener {

    private Button exitBtn;

    private EditText et_name, et_card_num, et_bank_type, et_card_net, et_phone;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_add_bankcard);
        EventBusHelper.register(this);
        initActionBar();
        initView();
    }

    private void initActionBar() {
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
        tvTitle.setText("添加银行卡");
    }

    private void initView() {
        exitBtn = (Button) findViewById(R.id.exit_btn);
        exitBtn.setOnClickListener(this);

        et_name = (EditText) findViewById(R.id.et_name);
        et_card_num = (EditText) findViewById(R.id.et_card_num);
        et_bank_type = (EditText) findViewById(R.id.et_bank_type);
        et_card_net = (EditText) findViewById(R.id.et_card_net);
        et_phone = (EditText) findViewById(R.id.et_phone);

//        mLv = (ListView) findViewById(R.id.lv_addr);
//        prefixList.add(new Prefix());
//        prefixList.add(new Prefix());
//        prefixList.add(new Prefix());
//
//        prefixList = InternationalizationHelper.getPrefixList();
//        prefixAdapter = new PrefixAdapter(prefixList);
//        mLv.setAdapter(prefixAdapter);
//
//        mLv.setOnItemClickListener(this);
    }

    // 获取用户的设置状态
    private void getBindInfo() {
//        userId=1000&
//                userName=100&
//                phone=11&
//                bankCart=123&
//                idNumber=3222222222&
//                openingBank=123123
        String bankUserName = et_name.getText().toString();
        if(TextUtils.isEmpty(bankUserName)){
            ToastUtil.showToast(AddBankCardActivity.this, "请输入姓名");
            return;
        }

        String bankNumber = et_card_num.getText().toString();
        if(!RegexUtils.checkBankNumber(bankNumber)){
            ToastUtil.showToast(AddBankCardActivity.this, "请输入正确格式银行卡号");
            return;
        }
        String bankNumberType = et_bank_type.getText().toString();

        if(TextUtils.isEmpty(bankNumberType)){
            ToastUtil.showToast(AddBankCardActivity.this, "请输入开户行");
            return;
        }
        String idCard = et_card_net.getText().toString();
        if(!RegexUtils.checkIdCard(idCard)){
            ToastUtil.showToast(AddBankCardActivity.this, "请输入正确格式身份证号");
            return;
        }

        String phone = et_phone.getText().toString();
        if(!RegexUtils.checkPhone(phone)){
            ToastUtil.showToast(AddBankCardActivity.this, "请输入正确格式手机号");
            return;
        }

        DialogHelper.showDefaulteMessageProgressDialog(this);
        HttpUtils.get().url(coreManager.getConfig().BIND_CARD)
                .params("access_token", coreManager.getSelfStatus().accessToken)
                .params("userId", coreManager.getSelf().getUserId())
                .params("userName", et_name.getText().toString())
                .params("phone", et_phone.getText().toString())
                .params("bankCart", et_card_num.getText().toString())
                .params("idNumber", et_card_net.getText().toString())
                .params("openingBank", et_bank_type.getText().toString())
                .build()
                .execute(new JsonCallback() {

                    @Override
                    public void onResponse(String result) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showToast(AddBankCardActivity.this, "绑定成功");
                        finish();
//                        JSONObject json = JSONObject.parseObject(result);
//                        JSONArray array = json.getJSONArray("data");
//                        isBandWx = array != null && array.size() > 0;
//                        updateUi();
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showToast(AddBankCardActivity.this, "绑定失败");
//                        updateUi();
                    }
                });
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.exit_btn:
                getBindInfo();

//                Intent intent = new Intent(AddBankCardActivity.this, BankCardDetailActivity.class);
//                intent.putExtra("name", et_name.getText().toString());
//                intent.putExtra("card", et_card_num.getText().toString());
//                startActivity(intent);
                break;
        }


    }

    @Subscribe(threadMode = ThreadMode.MainThread)
    public void helloEventBus(InputCard message) {
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

    }

    private class PrefixAdapter extends BaseAdapter {
        private List<Prefix> data;

        public PrefixAdapter(List<Prefix> data) {
            sort(data);
            this.data = data;
        }

        private void sort(List<Prefix> list) {
            Object[] a = list.toArray();
            Comparator<Prefix> c = new Comparator<Prefix>() {
                @Override
                public int compare(Prefix o1, Prefix o2) {
                    return o1.getEnName().compareTo(o2.getEnName());
                }
            };
            Arrays.sort(a, (Comparator) c);
            ListIterator<Prefix> i = list.listIterator();
            for (Object e : a) {
                i.next();
                i.set((Prefix) e);
            }
        }


        public void setData(List<Prefix> data) {
            sort(data);
            this.data = data;
            notifyDataSetChanged();
        }

        @Override
        public int getCount() {
            return data == null ? 0 : data.size();
        }

        @Override
        public Object getItem(int position) {
            return data.get(position);
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            PrefixAdapter.ViewHolder holder;
            if (convertView == null) {
                holder = new PrefixAdapter.ViewHolder();
                convertView = View.inflate(mContext, R.layout.item_bankcard, null);
                holder.tvBankName = (TextView) convertView.findViewById(R.id.tv_bank_name);
                holder.tvName = (TextView) convertView.findViewById(R.id.tv_name);
                holder.tvCardnum = (TextView) convertView.findViewById(R.id.tv_card_num);
                convertView.setTag(holder);
            } else {
                holder = (PrefixAdapter.ViewHolder) convertView.getTag();
            }
            holder.tvBankName.setText("邮政银行");
            holder.tvName.setText("asdf");
            holder.tvCardnum.setText("12354112341234");
            return convertView;
        }

        private class ViewHolder {
            TextView tvBankName, tvName, tvCardnum;
        }
    }
}
