package com.liaobo.im.ui.me;

import android.content.Intent;
import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.bean.CardModel;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.ui.base.BaseListActivity;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.ListCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ArrayResult;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import de.greenrobot.event.EventBus;
import okhttp3.Call;

/**
 * 绑定账号
 */
public class BankCardActivity  extends BaseListActivity<BankCardActivity.MyConsumeHolder> {

    private List<CardModel> prefixList = new ArrayList<>();

    @Override
    public void initView() {
        super.initView();
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
        tvTitle.setText("银行卡");

        ImageView ivTitleRight = (ImageView) findViewById(R.id.iv_title_right);
        ivTitleRight.setImageResource(R.drawable.ic_app_add);
        ivTitleRight.setOnClickListener(v -> {
            Intent intent = new Intent(BankCardActivity.this, AddBankCardActivity.class);
            startActivity(intent);
        });
    }

    @Override
    public void initDatas(int pager) {
        if (pager == 0) {
            prefixList.clear();
        }
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        params.put("userId", coreManager.getSelf().getUserId());
        params.put("page", String.valueOf(pager));
        params.put("limit", "10");
        HttpUtils.get().url(coreManager.getConfig().GET_CARD)
                .params(params)
                .build()
                .execute(new ListCallback<CardModel>(CardModel.class) {

                    @Override
                    public void onResponse(ArrayResult<CardModel> result) {
                        if (result.getData()!=null) {
                            prefixList = result.getData();
                            int adsf = prefixList.size();
                            if (prefixList.size() != 30) {
                                more = false;
                            } else {
                                more = true;
                            }
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    update(prefixList);
                                }
                            });
                        }else {
                            more = false;
                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showErrorNet(BankCardActivity.this);
                    }
                });
    }

    @Override
    public MyConsumeHolder initHolder(ViewGroup parent) {
        View v = mInflater.inflate(R.layout.item_bankcard, parent, false);
        MyConsumeHolder holder = new MyConsumeHolder(v);
        return holder;
    }

    @Override
    public void fillData(MyConsumeHolder holder, int position) {
        CardModel info = prefixList.get(position);
        holder.tvBankName.setText(info.getBankCart());
        holder.tvName.setText(info.getUserName());
        holder.tvCardnum.setText(info.getIdNumber());

        holder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EventBus.getDefault().post(info);
                finish();

            }
        });
    }

    public class MyConsumeHolder extends RecyclerView.ViewHolder {
        public  TextView tvBankName, tvName, tvCardnum;

        public MyConsumeHolder(View itemView) {
            super(itemView);
            tvBankName = (TextView) itemView.findViewById(R.id.tv_bank_name);
            tvName = (TextView) itemView.findViewById(R.id.tv_name);
            tvCardnum = (TextView) itemView.findViewById(R.id.tv_card_num);
        }
    }
}
