package com.liaobo.im.ui.me;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.bean.CardModel;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.ui.me.redpacket.ChangePayPasswordActivity;
import com.liaobo.im.ui.me.redpacket.PayPasswordVerifyDialog;
import com.liaobo.im.util.EventBusHelper;
import com.liaobo.im.util.Md5Util;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.BaseCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ObjectResult;

import de.greenrobot.event.Subscribe;
import de.greenrobot.event.ThreadMode;
import okhttp3.Call;

/**
 * 绑定账号
 */
public class BankCardTXActivity extends BaseActivity implements View.OnClickListener {

    private LinearLayout ll_select_card;
    private TextView foget_pw, tv_amount;
    private Button exit_btn;
    private RelativeLayout rl_tx;
    private TextView tv_card;

    private String amount, mCard;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_bankcard_tixian);
        EventBusHelper.register(this);
        initActionBar();
        initView();
//        getBindInfo();
    }

    private void initActionBar() {
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
        tvTitle.setText("银行卡");
    }

    private void initView() {
        amount = getIntent().getStringExtra("amount");

        foget_pw = (TextView) findViewById(R.id.foget_pw);
        foget_pw.setOnClickListener(this);

        tv_amount = (TextView) findViewById(R.id.tv_amount);
        tv_amount.setText(amount);

        ll_select_card = (LinearLayout) findViewById(R.id.ll_select_card);
        ll_select_card.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(BankCardTXActivity.this, BankCardActivity.class);
//                Intent intent = new Intent(BankCardTXActivity.this, AddBankCardActivity.class);
                startActivity(intent);
            }
        });

        exit_btn = (Button) findViewById(R.id.exit_btn);
        exit_btn.setOnClickListener(v -> {

        });
        exit_btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
//                rl_tx.setVisibility(View.VISIBLE);
                if (TextUtils.isEmpty(mCard)){
                    ToastUtil.showToast(BankCardTXActivity.this, R.string.input_card_num);
                    return;
                }
                showPayPassword();

            }
        });

        rl_tx = (RelativeLayout) findViewById(R.id.rl_tx);
        tv_card = (TextView) findViewById(R.id.tv_card);

    }
    private void showPayPassword(){
        PayPasswordVerifyDialog dialog = new PayPasswordVerifyDialog(this);
        dialog.setOnInputFinishListener(password -> {
            getBindInfo(password);
        });
        dialog.show();
    }

    // 获取用户的设置状态
    private void getBindInfo(String payPassword) {
//        入参 String bankCardId   银行卡id   Double amount 金额
        String md5PayPassword = Md5Util.toMD5(payPassword);
        DialogHelper.showDefaulteMessageProgressDialog(this);
        HttpUtils.get().url(coreManager.getConfig().TX_CARD)
                .params("access_token", coreManager.getSelfStatus().accessToken)
                .params("bankCardId", mCard)
                .params("amount", amount)
                .params("payPassword",md5PayPassword)
                .build()
                .execute(new BaseCallback<Void>(Void.class) {
                    @Override
                    public void onResponse(ObjectResult<Void> result) {

                        DialogHelper.dismissProgressDialog();
                        if (result.getResultCode()==1){
                            ToastUtil.showToast(BankCardTXActivity.this, "提现成功");
                            Intent intent = new Intent(BankCardTXActivity.this, TXDetailActivity.class);
                            intent.putExtra("amount", amount);
                            intent.putExtra("card", mCard.substring(mCard.length()-4, mCard.length()));
                            startActivity(intent);
                            finish();
                        }else {
                            ToastUtil.showToast(BankCardTXActivity.this, result.getResultMsg());
                        }


                    }
                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
//                        updateUi();
                    }
                });

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.foget_pw:
                Intent intent = new Intent(BankCardTXActivity.this, ChangePayPasswordActivity.class);
                startActivity(intent);
                break;
        }

    }

    @SuppressLint("SetTextI18n")
    @Subscribe(threadMode = ThreadMode.MainThread)
    public void helloEventBus(CardModel message) {
        mCard = message.getId();
        tv_card.setText(message.getOpeningBank() +"("+message.getIdNumber().substring(message.getIdNumber().length()-4, message.getIdNumber().length())+")");
    }
}
