package com.liaobo.im.ui.me.redpacket;

import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Parcelable;
import android.support.design.widget.TabLayout;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.text.Editable;
import android.text.InputType;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.liaobo.im.R;
import com.liaobo.im.db.InternationalizationHelper;
import com.liaobo.im.fragment.MucSendPacketFragment;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.ui.base.CoreManager;
import com.liaobo.im.ui.base.EasyFragment;
import com.liaobo.im.ui.message.ChatActivity;
import com.liaobo.im.ui.message.MucChatActivity;
import com.liaobo.im.ui.smarttab.SmartTabLayout;
import com.liaobo.im.util.Constants;
import com.liaobo.im.util.InputChangeListener;
import com.liaobo.im.util.PreferenceUtils;
import com.liaobo.im.util.ToastUtil;

import org.jivesoftware.smack.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by 魏正旺 on 2016/9/8.
 */
public class MucSendRedPacketActivity extends BaseActivity  {

    private TabLayout mTabRedPacket;
    private ViewPager viewPager;
    private String roomId;


    private List<EasyFragment> mFragmentList;
    private TabFragmentPagerAdapter mPagerAdapter;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_muc_redpacket);
        roomId = getIntent().getStringExtra("roomId");
        initView();

        checkHasPayPassword();
    }

    private void checkHasPayPassword() {
        boolean hasPayPassword = PreferenceUtils.getBoolean(this, Constants.IS_PAY_PASSWORD_SET + coreManager.getSelf().getUserId(), true);
        if (!hasPayPassword) {
            ToastUtil.showToast(this, R.string.tip_no_pay_password);
            Intent intent = new Intent(this, ChangePayPasswordActivity.class);
            startActivity(intent);
            finish();
        }
    }

    private void initView() {
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(view -> finish());
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
        tvTitle.setText(InternationalizationHelper.getString("JX_SendGift"));
        mFragmentList = new ArrayList<>();
        mTabRedPacket = findViewById(R.id.tab_red_packet);
        viewPager =  findViewById(R.id.muc_viewpager);
        initTabLayout();

    }

    private void initFragment(){
        MucSendPacketFragment luckFragment = new MucSendPacketFragment();
        luckFragment.setRedPacketType(2);
        luckFragment.setRoomId(roomId);
        mFragmentList.add(luckFragment);
        MucSendPacketFragment normalFragment = new MucSendPacketFragment();
        normalFragment.setRedPacketType(1);
        normalFragment.setRoomId(roomId);
        mFragmentList.add(normalFragment);
        mPagerAdapter = new TabFragmentPagerAdapter(getSupportFragmentManager(),mFragmentList);
        viewPager.setAdapter(mPagerAdapter);
        viewPager.setOffscreenPageLimit(mFragmentList.size());

    }

    private void initTabLayout(){
        initFragment();

        mTabRedPacket.setupWithViewPager(viewPager);
        mTabRedPacket.removeAllTabs();

        mTabRedPacket.addTab(  mTabRedPacket.newTab().setText(InternationalizationHelper.getString("JX_LuckGift")));//手气红包
        mTabRedPacket.addTab(  mTabRedPacket.newTab().setText(InternationalizationHelper.getString("JX_UsualGift")));//普通红包
        mTabRedPacket.setTabIndicatorFullWidth(false);
        mTabRedPacket.setInlineLabel(true);
        mTabRedPacket.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });

    }



    private class TabFragmentPagerAdapter extends FragmentPagerAdapter {

        private List<EasyFragment> mFragmentList;
        public TabFragmentPagerAdapter(FragmentManager fm, List<EasyFragment> list) {
            super(fm);
            this.mFragmentList = list;
        }

        @Override
        public void setPrimaryItem(ViewGroup container, int position, Object object) {
            super.setPrimaryItem(container, position, object);
        }

        @Override
        public EasyFragment getItem(int position) {
            return mFragmentList.get(position);//显示第几个页面
        }

        @Override
        public int getCount() {
            return mFragmentList.size();//有几个页面
        }

    }
}
