package com.liaobo.im.ui.me.redpacket;

import android.content.Intent;
import android.os.Bundle;
import android.text.Html;
import android.text.TextUtils;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Spinner;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.bean.redpacket.RedPacketReceiveBean;
import com.liaobo.im.helper.AvatarHelper;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.BaseCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ObjectResult;
import com.makeramen.roundedimageview.RoundedImageView;

import java.util.HashMap;

import okhttp3.Call;

public class MyRedPacketActivity extends BaseActivity {
    private RoundedImageView mAvatarImg;
    private TextView tvUserId,tvReceivePacket,tvLucy, tvRedPacketMoney;
    private Spinner mSpinner;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_my_red_packet);

        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(view -> finish());
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);

        tvTitle.setText(R.string.my_red_packet);
        tvUserId = findViewById(R.id.tv_userId);
        tvReceivePacket = findViewById(R.id.tv_lucy);
        tvLucy = findViewById(R.id.receive_packet);
        tvRedPacketMoney = findViewById(R.id.tv_red_packet_money);
        mAvatarImg = findViewById(R.id.avatar_img);
        mSpinner = findViewById(R.id.spinner_packet);
        AvatarHelper.getInstance().displayAvatar(coreManager.getSelf().getUserId(), mAvatarImg, true);
        tvUserId.setText(coreManager.getSelf().getUserId());
        findViewById(R.id.received_red_packet).setOnClickListener(view -> {
            Intent intent = new Intent(this,RedListActivity.class);
            intent.putExtra(RedListActivity.ADAPTER_TYPE,0);
            startActivity(intent);
        });
        findViewById(R.id.send_red_packet).setOnClickListener(view -> {
            Intent intent = new Intent(this,RedListActivity.class);
            intent.putExtra(RedListActivity.ADAPTER_TYPE,1);
            startActivity(intent);
        });
        initSpinner();
        loadReceiveRedPacket(null,null);


    }

    private void loadReceiveRedPacket(String startTime,String endTime) {
        DialogHelper.showMessageProgressDialog(this,"请稍等...");
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        params.put("pageIndex",   "0");
        params.put("pageSize", "25");
        if (!TextUtils.isEmpty(startTime)){
            params.put("startTime",startTime);
        }
        if (!TextUtils.isEmpty(endTime)){
            params.put("endTime",endTime);
        }



        HttpUtils.get().url(coreManager.getConfig().RECIVE_REDPACKET_LIST_GET)
                .params(params)
                .build()
                .execute(new BaseCallback<RedPacketReceiveBean>(RedPacketReceiveBean.class) {

                    @Override
                    public void onResponse(ObjectResult<RedPacketReceiveBean> result) {
                        DialogHelper.dismissProgressDialog();
                        updateUI(result.getData());


                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                    }
                });
    }

    private void updateUI(RedPacketReceiveBean receiveBean){

        if (receiveBean!=null){
            tvLucy.setText(Html.fromHtml(getResources().getString(R.string.red_best_lucky)+"<font color='#159bfb'>"+receiveBean.bestSum+"</font>次"));
            tvReceivePacket.setText(Html.fromHtml(getResources().getString(R.string.received_red_packet)+"<font color='#159bfb'>"+receiveBean.redReceiveSum+"</font>个"));
            tvRedPacketMoney.setText("￥"+receiveBean.amountSum);
        }


    }

    private void initSpinner(){

        mSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> adapterView, View view, int position, long l) {
                long currentTime = System.currentTimeMillis()/1000;
                int day = 0;
                switch (position){
                    case 1:
                        day = 7;
                        break;
                    case 2:
                        day =30;
                        break;
                    case 3:
                        day=90;
                        break;
                    default:
                        day=-1;
                        break;
                }
                long startTime = getStartTime(currentTime,day);
            loadReceiveRedPacket(String.valueOf(startTime),String.valueOf(currentTime));
            }

            @Override
            public void onNothingSelected(AdapterView<?> adapterView) {

            }
        });


    }
    private long getStartTime(long currentTime,int day){
        if (day==-1) return 0;
        long startTime = currentTime - day*24*3600;
        return  startTime;

    }


}