package com.liaobo.im.ui.me.redpacket;

import android.support.v7.widget.RecyclerView;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.liaobo.im.R;
import com.liaobo.im.bean.TTXHistoryModel;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.ui.base.BaseListActivity;
import com.liaobo.im.util.ToastUtil;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.ListCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ArrayResult;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import okhttp3.Call;

/**
 * Created by wzw on 2016/9/26.
 */
public class QuxianHistiry extends BaseListActivity<QuxianHistiry.MyConsumeHolder> {
    private static final String TAG = "QuxianHistiry";
    List<TTXHistoryModel> datas = new ArrayList<>();

    @Override
    public void initView() {
        super.initView();
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
    }

    @Override
    public void initDatas(int pager) {
        if (pager == 0) {
            datas.clear();
        }
        HashMap<String, String> params = new HashMap<String, String>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        // 如果是下拉刷新就重新加载第一页
        params.put("pageIndex", pager + "");
        params.put("pageSize", "30");
        HttpUtils.get().url(coreManager.getConfig().TX_HISTORY)
                .params(params)
                .build()
                .execute(new ListCallback<TTXHistoryModel>(TTXHistoryModel.class) {

//                    @Override
//                    public void onResponse(ObjectResult<List<TTXHistoryModel>> result) {
//                        if (result.getData() != null) {
//                            for (TTXHistoryModel.DataBean data : result.getData().getData()) {
//                                final double money = data.getSjtxje();
//                                boolean isZero = Double.toString(money).equals("0.0");
//                                Log.d(TAG, "bool : " + isZero + " \t" + money);
//                                if (!isZero) {
//                                    datas = result.getData();
//                                }
//                            }
//                            if (result.getData().getData().size() != 30) {
//                                more = false;
//                            } else {
//                                more = true;
//                            }
//                        } else {
//                            more = false;
//                        }
//                        runOnUiThread(new Runnable() {
//                            @Override
//                            public void run() {
//                                update(datas);
//                            }
//                        });
//                    }

                    @Override
                    public void onResponse(ArrayResult<TTXHistoryModel> result) {
                        DialogHelper.dismissProgressDialog();
                        if (result.getData()!=null) {
                            datas = result.getData();
                            int adsf = datas.size();
                            if (datas.size() != 30) {
                                more = false;
                            } else {
                                more = true;
                            }
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    update(datas);
                                }
                            });
                        }else {
                            more = false;
                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showErrorNet(QuxianHistiry.this);
                    }
                });
    }

    @Override
    public MyConsumeHolder initHolder(ViewGroup parent) {
        View v = mInflater.inflate(R.layout.item_tx_history, parent, false);
        MyConsumeHolder holder = new MyConsumeHolder(v);
        return holder;
    }

    @Override
    public void fillData(MyConsumeHolder holder, int position) {
        TTXHistoryModel info = datas.get(position);
        holder.tvShenheStatus.setText(info.getAuditMsg());
        holder.textviewMoney.setText(String.valueOf(info.getAmount()));
        holder.textviewFeilv.setText(String.valueOf(info.getRate()));
        holder.textviewHave.setText(String.valueOf(info.getSjtxje()));
        holder.textviewMoneyHas.setText(String.valueOf(info.getBalance()));
        holder.textviewTime.setText(info.getServiceTime());
    }

    public class MyConsumeHolder extends RecyclerView.ViewHolder {
        public TextView tvShenheStatus, textviewMoney, textviewFeilv, textviewHave, textviewMoneyHas, textviewTime;

        public MyConsumeHolder(View itemView) {
            super(itemView);
            tvShenheStatus = (TextView) itemView.findViewById(R.id.tv_shenhe_status);
            textviewMoney = (TextView) itemView.findViewById(R.id.textview_money);
            textviewFeilv = (TextView) itemView.findViewById(R.id.textview_feilv);
            textviewHave = (TextView) itemView.findViewById(R.id.textview_have);
            textviewMoneyHas = (TextView) itemView.findViewById(R.id.textview_money_has);
            textviewTime = (TextView) itemView.findViewById(R.id.textview_time);
        }
    }
}
