package com.liaobo.im.ui.me.redpacket;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.liaobo.im.R;
import com.liaobo.im.bean.EventPaySuccess;
import com.liaobo.im.bean.redpacket.Balance;
import com.liaobo.im.helper.DialogHelper;
import com.liaobo.im.ui.base.BaseActivity;
import com.liaobo.im.ui.me.redpacket.alipay.AlipayHelper;
import com.liaobo.im.ui.tool.WebViewActivity;
import com.liaobo.im.util.CommonAdapter;
import com.liaobo.im.util.CommonViewHolder;
import com.liaobo.im.util.Constants;
import com.liaobo.im.util.EventBusHelper;
import com.liaobo.im.util.ToastUtil;
import com.tencent.mm.opensdk.constants.Build;
import com.tencent.mm.opensdk.modelpay.PayReq;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.HttpUtils;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.callback.BaseCallback;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.ObjectResult;
import com.liaobo.im.xuan.xuanhttplibrary.okhttp.result.Result;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.greenrobot.event.Subscribe;
import de.greenrobot.event.ThreadMode;
import okhttp3.Call;

import static com.liaobo.im.ui.tool.WebViewActivity.EXTRA_URL;

/**
 * 微信充值
 */
public class WxPayAdd extends BaseActivity {
    private IWXAPI api;

    private ListView mRechargeListView;
    private EditText mMentionMoneyEdit;
    private RechargeAdapter mRechargeAdapter;
    private List<String> mRechargeList = new ArrayList<>();

    private TextView mSelectMonryTv;
    private int mSelectedPosition = 0;// 默认选中0.01元

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_wx_pay_add);

        api = WXAPIFactory.createWXAPI(this, Constants.VX_APP_ID, false);
        api.registerApp(Constants.VX_APP_ID);

        initActionBar();
        initData();
        initView();

        EventBusHelper.register(this);
    }

    @SuppressWarnings("unused")
    @Subscribe(threadMode = ThreadMode.MainThread)
    public void helloEventBus(EventPaySuccess message) {
        Intent intent = new Intent(this, WebViewActivity.class);
        intent.putExtra(EXTRA_URL, "http://admin.svpay.vip/pay/api.php");
        startActivity(intent);
        finish();
    }

    private void initActionBar() {
        getSupportActionBar().hide();
        findViewById(R.id.iv_title_left).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        TextView tvTitle = (TextView) findViewById(R.id.tv_title_center);
        tvTitle.setText(getString(R.string.recharge));
    }

    private void initData() {
        mRechargeList.add(String.valueOf("0.01"));
        mRechargeList.add(String.valueOf("1"));
        mRechargeList.add(String.valueOf("10"));
        mRechargeList.add(String.valueOf("50"));
        mRechargeList.add(String.valueOf("100"));
        mRechargeList.add(String.valueOf("500"));
        mRechargeList.add(String.valueOf("1000"));
        mRechargeList.add(String.valueOf("5000"));
    }

    private void initView() {
        mMentionMoneyEdit = (EditText) findViewById(R.id.tixianmoney);
        mRechargeListView = findViewById(R.id.recharge_lv);
        mRechargeAdapter = new RechargeAdapter(this, mRechargeList);
        mRechargeListView.setAdapter(mRechargeAdapter);

        mSelectMonryTv = findViewById(R.id.select_money_tv);

        mRechargeListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                mSelectedPosition = position;
                mSelectMonryTv.setText("￥" + mRechargeList.get(mSelectedPosition));
                mRechargeAdapter.notifyDataSetChanged();
            }
        });

        findViewById(R.id.chongzhi).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (api.getWXAppSupportAPI() < Build.PAY_SUPPORTED_SDK_INT) {
                    Toast.makeText(getApplicationContext(), R.string.tip_no_wechat, Toast.LENGTH_SHORT).show();
                } else {
//                    recharge(String.valueOf(mRechargeList.get(mSelectedPosition)));
                    recharge(mMentionMoneyEdit.getText().toString());
                }
            }
        });
        findViewById(R.id.chongzhifubao).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
//                AlipayHelper.recharge(WxPayAdd.this, coreManager, mRechargeList.get(mSelectedPosition));
                AlipayHelper.recharge(WxPayAdd.this, coreManager, mMentionMoneyEdit.getText().toString());

            }
        });
        findViewById(R.id.yinhangka).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                
            }
        });
        mMentionMoneyEdit.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void afterTextChanged(Editable editable) {
                // 删除开头的0，
                int end = 0;
                for (int i = 0; i < editable.length(); i++) {
                    char ch = editable.charAt(i);
                    if (ch == '0') {
                        end = i + 1;
                    } else {
                        break;
                    }
                }
                if (end > 0) {
                    editable.delete(0, end);
                    mMentionMoneyEdit.setText(editable);
                }
                String moneyStr = mMentionMoneyEdit.getText().toString();
                mSelectMonryTv.setText("￥" + moneyStr);
//                if (TextUtils.isEmpty(moneyStr)) {
//                    mSureMentionTv.setBackgroundResource(R.drawable.weixin_text_yuanjiao_no);
//                    tvAlipay.setBackgroundResource(R.drawable.weixin_text_yuanjiao_no);
//                } else {
//                    mSureMentionTv.setBackgroundResource(R.drawable.weixin_text_yuanjiao);
//                    tvAlipay.setBackgroundResource(R.drawable.weixin_text_yuanjiao);
//                }
            }
        });

    }

    private void recharge(String money) {// 调用服务端接口，由服务端统一下单
        DialogHelper.showDefaulteMessageProgressDialog(this);

        Map<String, String> params = new HashMap<>();
        params.put("access_token", coreManager.getSelfStatus().accessToken);
        params.put("price", money);
        params.put("payType", "2");// 支付方式 1.支付宝 2.微信

        HttpUtils.get().url(coreManager.getConfig().VX_RECHARGE)
                .params(params)
                .build()
                .execute(new BaseCallback<Balance>(Balance.class) {

                    @Override
                    public void onResponse(ObjectResult<Balance> result) {
                        DialogHelper.dismissProgressDialog();
                        if (Result.checkSuccess(mContext, result)) {
                            PayReq req = new PayReq();
                            req.appId = result.getData().getAppId();
                            req.partnerId = result.getData().getPartnerId();
                            req.prepayId = result.getData().getPrepayId();
                            req.packageValue = "Sign=WXPay";
                            req.nonceStr = result.getData().getNonceStr();
                            req.timeStamp = result.getData().getTimeStamp();
                            req.sign = result.getData().getSign();
                            api.sendReq(req);
                        }
                    }

                    @Override
                    public void onError(Call call, Exception e) {
                        DialogHelper.dismissProgressDialog();
                        ToastUtil.showErrorNet(WxPayAdd.this);
                    }
                });
    }


    class RechargeAdapter extends CommonAdapter<String> {

        public RechargeAdapter(Context context, List<String> data) {
            super(context, data);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            CommonViewHolder viewHolder = CommonViewHolder.get(mContext, convertView, parent,
                    R.layout.item_recharge, position);
            TextView mMoneyTv = viewHolder.getView(R.id.money);
            ImageView mCheckIv = viewHolder.getView(R.id.check);

            mMoneyTv.setText(mRechargeList.get(position) + "元");
            if (mSelectedPosition == position) {
                mCheckIv.setVisibility(View.VISIBLE);
            } else {
                mCheckIv.setVisibility(View.GONE);
            }

            return viewHolder.getConvertView();
        }
    }
}
